; -------- Include Files and Libraries --------------------------------------------------------------------------------
.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\masm32.inc

; include \masm32\macros\macros.asm

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib

INCLUDE \masm32\include\Gdi32.inc
INCLUDELIB \masm32\lib\Gdi32.lib
	
; -------- Initialised Data -------------------------------------------------------------------------------------------
.data
fileNameToOpen	db 'test.txt',0		; file to read
fileNotFoundException	db 'file not found',0
generalException	db 'general exception',0

; -------- UnInitialised Data -----------------------------------------------------------------------------------------
.data?
hFile	dd ?
fileSize	dd ?
hMem	dd ?
bytesRead	dd ?

hInstance	dd ?
hWinGraphic	dd ?
hMainHeap	DWORD ?
; -------- Program Code -----------------------------------------------------------------------------------------------
.code

main	PROTO 
allocateUsingHeapAlloc	PROTO hHeap:DWORD, dwBytes:DWORD


start:	
	invoke	GetProcessHeap
	mov		hMainHeap, eax	
	invoke  main	
	
    invoke  ExitProcess,0

main proc
	xor eax,eax
	invoke GetModuleHandle, NULL
    mov    hInstance,eax	        					
    invoke  CreateFile,ADDR fileNameToOpen,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
        	
    .IF eax == INVALID_HANDLE_VALUE
		invoke  StdOut,addr fileNotFoundException
		invoke  ExitProcess,0
	.ENDIF            	
    mov     hFile,eax    
    
    invoke  GetFileSize,eax,0
    mov     fileSize,eax
    inc     eax               
           
    invoke  allocateUsingHeapAlloc,hMainHeap, eax
    mov     hMem,eax
                
    mov     BYTE PTR [eax],0 
    invoke  ReadFile,hFile,hMem,fileSize,ADDR bytesRead,0
    invoke  CloseHandle,hFile
    invoke  StdOut,hMem
    invoke  HeapFree, hMainHeap, 0 , hMem
	ret       	
main endp

; -----------------------------------------------------------------------------
;NAME:           allocateUsingHeapAlloc
;DESCRIPTION:    Memory allocation

;allocateUsingHeapAlloc returns the address of block of memory from an existing heap, 
;identified by a heap handle. The allocated memory cannot be moved. 
;If the memory cannot be allocated, the function returns NULL (0).
; -----------------------------------------------------------------------------
allocateUsingHeapAlloc PROC STDCALL PUBLIC uses EDI ESI EBX hHeap:DWORD, dwBytes:DWORD	
		                   	
	invoke  HeapAlloc,hHeap, HEAP_ZERO_MEMORY,dwBytes
	.IF eax == NULL
		;invoke  StdOut,addr generalException	 	
 		;mov eax,FALSE
 		ret
 	.endif	 
	ret
allocateUsingHeapAlloc endp

END start
OPT_Tmp2Asm	1
